
namespace cube_performance_counter
{
	class Class1
	{
		private static string category = "Rubik's Cube";
		private static string counter_min = "Min FPS";
		private static string counter_max = "Max FPS";
		private static string counter_avg = "Avg FPS";

		static bool counters_exist(){
			bool result = false;
			if ( System.Diagnostics.PerformanceCounterCategory.Exists(category) ){
				System.Diagnostics.PerformanceCounterCategory c = new System.Diagnostics.PerformanceCounterCategory(category);
				if (c.CounterExists(counter_min) && c.CounterExists(counter_max) && c.CounterExists(counter_avg))
					result = true;
			}
			return result;
		}

		static System.Diagnostics.CounterCreationData create_counter(string name)
		{
			System.Diagnostics.CounterCreationData result = new System.Diagnostics.CounterCreationData();
			result.CounterType = System.Diagnostics.PerformanceCounterType.NumberOfItems32;
			result.CounterName = name;
			return result;
		}

		static void create_counters(){
			System.Diagnostics.CounterCreationDataCollection CCDC = new System.Diagnostics.CounterCreationDataCollection();

			CCDC.Add(create_counter(counter_min));
			CCDC.Add(create_counter(counter_avg));
			CCDC.Add(create_counter(counter_max));

			try
			{
				System.Diagnostics.PerformanceCounterCategory.Create(category, "SV counter.", CCDC);
				System.Console.WriteLine("Performance counters in " + category + " category successfully created.");
			}
			catch(System.Exception e)
			{
				System.Console.WriteLine("Creation of counter in " + category + " category failed: " + e.Message);
			}
		}

		static void remove_counters()
		{
			try
			{
				System.Diagnostics.PerformanceCounterCategory.Delete(category);
				System.Console.WriteLine("Performance counter category " + category + " successfully removed.");
			}
			catch(System.Exception e)
			{
				System.Console.WriteLine("Delete of counter category " + category + " failed: " + e.Message);
			}
		}

		[System.STAThread]
		static void Main(string[] args)
		{
			if ( counters_exist() )
				remove_counters();
			else
				create_counters();
		}
	}
}
