class
	ABOUT_DIALOG
	
inherit
	WINFORMS_FORM
		rename 
			make as base_make
		undefine
			equals, get_hash_code, to_string, finalize
		end
	MISC
	
create
	make
	
feature {NONE} make(parent_window: WINFORMS_FORM) is
		local 
			dummy: WINFORMS_DIALOG_RESULT
			picture: WINFORMS_PICTURE_BOX
			cube_icon: DRAWING_ICON
			copyright, version: WINFORMS_LABEL
			homepage: WINFORMS_LINK_LABEL
			hidden_button_with_focus: WINFORMS_BUTTON
		do
			base_make
			
			set_text("[Rubik's Cube] About")
			set_form_border_style(feature {WINFORMS_FORM_BORDER_STYLE}.fixed_3_d)
			
			create version.make
			version.set_text("Version 1.00. October 22, 2003.")
			version.set_location(create {DRAWING_POINT}.make(Left_offset, Top_offset))
			version.set_size(create {DRAWING_SIZE}.make(Text_width, Text_height))
			version.set_text_align(feature {DRAWING_CONTENT_ALIGNMENT}.middle_center)
			
			create copyright.make
			copyright.set_text("Copyright (C) 2003 Sergey Vlasov")
			copyright.set_location(create {DRAWING_POINT}.make(Left_offset, Top_offset + Vertical_offset))
			copyright.set_size(create {DRAWING_SIZE}.make(Text_width, Text_height))
			copyright.set_text_align(feature {DRAWING_CONTENT_ALIGNMENT}.middle_center)
			
			create homepage.make
			homepage.set_text("www.svprogramming.net")
			homepage.add_link_clicked(create {WINFORMS_LINK_LABEL_LINK_CLICKED_EVENT_HANDLER}.make(Current, $on_homepage_click))
			homepage.set_location(create {DRAWING_POINT}.make(Left_offset, Top_offset + Vertical_offset * 2))
			homepage.set_size(create {DRAWING_SIZE}.make(Text_width, Text_height) )
			homepage.set_text_align(feature {DRAWING_CONTENT_ALIGNMENT}.middle_center)
			
			create cube_icon.make_from_stream(load_resource_as_stream("cube.ico", "cube resources"))
			create picture.make
			picture.set_location(create {DRAWING_POINT}.make(20, 20))
			picture.set_image(cube_icon.to_bitmap)
			
				-- To remove focus from "homepage":
			create hidden_button_with_focus.make 
			hidden_button_with_focus.set_location(create {DRAWING_POINT}.make(-100, -100))
			controls.add(hidden_button_with_focus) 
			
			controls.add(version)
			controls.add(copyright)
			controls.add(homepage)
			controls.add(picture)
			
			set_width(320)
			set_height(130)
			set_top_level(True) -- To bring window in front of main view, when going from fullscreen mode
			dummy := show_dialog_iwin_32_window(parent_window)
		end
	
feature {NONE} on_homepage_click(sender: SYSTEM_OBJECT args: WINFORMS_LINK_LABEL_LINK_CLICKED_EVENT_ARGS) is
		local 
			dummy:  SYSTEM_DLL_PROCESS
		do
			dummy := feature {SYSTEM_DLL_PROCESS}.start_string("http://www.svprogramming.net")
		end
	
feature {NONE} 
	Top_offset: INTEGER is 15
	Left_offset: INTEGER is 75 
	Text_height: INTEGER is 20 
	Text_width: INTEGER is 220
	Vertical_offset: INTEGER is 25
	
	
end


