indexing
	description: "Angle from 0 to 360 degrees"
	notes: "Value type"
	
class
	ANGLE
	
inherit
	ANY
		redefine
			is_equal, copy
		end	
	
create
	make	
	
feature value: DOUBLE
	
feature make(init_value_degrees: like value) is
		require
			valid_angle(init_value_degrees)
		do
			value := init_value_degrees
		end
	
feature infix "+" (other: like Current): like Current is
		require
			other /= Void
		do
			Result := clone(Current)
			Result.add(other)
		ensure
			Result /= Void	
		end
	
feature infix "-" (other: like Current): like Current is
		require
			other /= Void
		do
			Result := clone(Current)
			Result.sub(other)
		ensure
			Result /= Void	
		end
	
feature add(other: like Current) is
		require
			other /= Void
		local 
			new_value: like value
		do
			new_value := value + other.value
			if new_value >= 360.0 then
				new_value := new_value - 360.0
			end		
			value := new_value
		end
	
feature sub(other: like Current) is
		require
			other /= Void
		local 
			new_value: like value
		do
			new_value := value - other.value
			if new_value < 0.0 then
				new_value := new_value + 360.0
			end
			value := new_value
		end
	
feature valid_angle(angle: like value): BOOLEAN is
		do
			Result := angle >= 0.0 and angle < 360.0
		end
	
feature is_equal(other: like Current): BOOLEAN is
		do
			Result := (value - other.value).abs < 1.0e-10
		end		
	
feature copy(other: like Current) is
		do
			value := other.value
		end		
	
invariant
	valid_angle(value)
	
end 
