indexing
	notes: "Immutable"
	
class
	CUBE_PLANE_PARAMETERS
	
inherit
	ANY 
		redefine 
			is_equal, copy 
		end	
	
create
	make
	
feature	
	orientation: INTEGER
	index: IDEAL_CUBE_INDEX
	
feature	{NONE} make(new_orientation: like orientation; new_index: like index) is
		require
			new_index /= Void
		do
			orientation := new_orientation
			index := new_index
		end
	
feature has(brick: IDEAL_BRICK): BOOLEAN is
		require
			brick /= Void
		do
			if 
					orientation = feature {ORIENTATION}.Vertical_perpendicular_to_x and brick.position.x.is_equal(index)
				or
					orientation = feature {ORIENTATION}.Vertical_perpendicular_to_y and brick.position.y.is_equal(index)
				or
					orientation = feature {ORIENTATION}.Horizontal and brick.position.z.is_equal(index)
			 then
				Result := True
			end	
		end
	
feature is_equal(other: like Current): BOOLEAN is
		do
			Result := orientation.is_equal(other.orientation) and index.is_equal(other.index)
		end
	
feature copy(other: like Current) is	
		do
			orientation := other.orientation
			index := clone(other.index)
		end
	
invariant
	index /= Void
	
end 
