
class
    CUSTOM_SETTINGS
	
inherit
	MISC
		redefine
			default_create
		end
	
feature
	window_width, window_height, shuffle_count: INTEGER     
	is_fullscreen, is_software_rendering, is_black_background: BOOLEAN	           
	
feature {NONE} default_create is
		do
			window_width := load_non_negative_integer_from_config("Window width")
			if not (window_width > 0) then
				window_width := 300
			end   
			
			window_height := load_non_negative_integer_from_config("Window height")
			if not (window_height > 0) then
				window_height := 320
			end   
			
			shuffle_count := load_non_negative_integer_from_config("Shuffle count")
			if shuffle_count = -1 then
				shuffle_count := 50
			end   
			
			is_fullscreen := load_boolean_from_config("Start in fullscreen")
			is_software_rendering := load_boolean_from_config("Software rendering")
			is_black_background := load_boolean_from_config("Black background")
		end
	
invariant
	window_width > 0
	window_height > 0
	shuffle_count >= 0	
	
end 
