indexing
	notes: "Immutable"
	
class
	DIRECTION
	
inherit
	ANY 
		redefine 
			is_equal, copy, default_create 
		end	
	
create
	default_create
	
create {DIRECTION}
	make
	
	
feature {NONE} default_create is
		do
			create value.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))
		end	
	
feature rotate(orientation: INTEGER rotate_count: ROTATE_COUNT): DIRECTION is
		require
			rotate_count /= Void
		do
			create Result.make(value.rotate(orientation, rotate_count)) 
		ensure
			Result /= Void	
		end
	
feature Front: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))) 
		end
	
feature Back: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(-1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))) 
		end
	
feature Left: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0))) 
		end
	
feature Right: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1), create {IDEAL_CUBE_INDEX}.make(0))) 
		end
	
feature Top: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))) 
		end
	
feature Bottom: DIRECTION is
		once
			create Result.make(create {IDEAL_BRICK_POSITION}.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1))) 
		end
	
feature copy(other: like Current) is
		do
			value := clone(other.value)
		end	
	
feature is_equal(other: like Current): BOOLEAN is
		do
			Result := value.is_equal(other.value)
		end
	
	
feature {NONE} make(new_value: like value) is
		require
			new_value /= Void and then valid_value(new_value)
		do
			value := new_value
		end		
	
feature {NONE} valid_value(p: like value): BOOLEAN is
		require
			p /= Void
		local
			two_zeros, one_or_negative_one: BOOLEAN	
		do
			two_zeros := 
				p.x.value = 0 and p.y.value = 0 
				or 
				p.x.value = 0 and p.z.value = 0 
				or 
				p.z.value = 0 and p.y.value = 0
			one_or_negative_one := p.x.value.abs = 1 or p.y.value.abs = 1 or p.z.value.abs = 1			
			Result := two_zeros and one_or_negative_one
		end		
	
feature {DIRECTION} value: IDEAL_BRICK_POSITION
	
invariant
	value /= Void and then valid_value(value)
	
	
	
end 
