indexing
	notes: "Immutable"
	
class
	IDEAL_BRICK_POSITION
	
inherit 
	MATH_MISC 
		redefine 
			is_equal, copy 
		end
	
create
	make
	
feature	x, y, z: IDEAL_CUBE_INDEX
	
feature {NONE} make(new_x, new_y, new_z: like x) is
		require
			new_x /= Void
			new_y /= Void
			new_z /= Void
		do
			x := new_x
			y := new_y
			z := new_z
		end
	
feature rotate(orientation: INTEGER rotate_count: ROTATE_COUNT): like Current is
		require
			rotate_count /= Void
		local 
			cos, sin: INTEGER
			new_x, new_y, new_z: like x
		do
			cos := integer_cos(rotate_count.count)
			sin := integer_sin(rotate_count.count)
			inspect
				orientation
			when feature {ORIENTATION}.Horizontal then
				create new_x.make(x.value * cos - y.value * sin)
				create new_y.make(x.value * sin + y.value * cos)
				new_z := clone(z)
			when feature {ORIENTATION}.Vertical_perpendicular_to_x then
				create new_y.make(y.value * cos - z.value * sin)
				create new_z.make(y.value * sin + z.value * cos)
				new_x := clone(x)
			when feature {ORIENTATION}.Vertical_perpendicular_to_y then
				create new_z.make(z.value * cos - x.value * sin)
				create new_x.make(z.value * sin + x.value * cos)
				new_y := clone(y)
			end
			create Result.make(new_x, new_y, new_z)
		ensure
			Result /= Void	
		end
	
	
feature copy(other: like Current) is	
		do
			x := clone(other.x)
			y := clone(other.y)
			z := clone(other.z)
		end
	
feature is_equal (other: like Current): BOOLEAN is
		do
			Result := x.is_equal(other.x) and y.is_equal(other.y) and z.is_equal(other.z) 
		end
	
invariant
	x /= Void
	y /= Void
	z /= Void
	
	
end 
