
class
    KEY_MANAGER
	
feature {NONE} make is
		do
			create key_handlers.make(0)
		end
	
feature process_key(key: WINFORMS_KEYS) is
		require
			valid_key(key)
		local
			i: INTEGER
		do
			--key_handlers.do_all(agent process_key_on_handler(key, ?))
			from i := 1 until i > key_handlers.count loop
				try_key_on_handler(key, key_handlers.i_th(i))
				i := i + 1
			end
		end
	
feature valid_key(key: WINFORMS_KEYS): BOOLEAN is
		local
			i: INTEGER
		do
			--Result := key_handlers.there_exists(agent is_handler_for_key(?, key))
			from i := 1 until i > key_handlers.count loop
				if is_handler_for_key(key_handlers.i_th(i), key) then
					Result := True
				end
				i := i + 1
			end
		end	
	
feature {NONE} try_key_on_handler(key: WINFORMS_KEYS key_handler: KEY_HANDLER) is		
		require
			key_handler /= Void
		do
			if is_handler_for_key(key_handler, key) and then key_handler.condition.item([]) then
				key_handler.command.call([])
			end
		end
	
feature {NONE} is_handler_for_key(key_handler: KEY_HANDLER key: WINFORMS_KEYS): BOOLEAN is
		require
			key_handler /= Void
		do
			Result := key_handler.key = key
		end 		
	
	
feature {NONE} add_key_handler(key_handler: KEY_HANDLER) is
		require
			key_handler /= Void
		do
			key_handlers.extend(key_handler)
		end 		
	
feature {NONE} key_handlers: ARRAYED_LIST[KEY_HANDLER] 		
	
invariant	
	key_handlers /= Void and not key_handlers.has(Void)
	
end 
