class
	MAIN_FORM
	
inherit
	WINFORMS_FORM
		rename
			make as make_base_form
		undefine
			equals, get_hash_code, to_string, finalize
		redefine
			on_paint, on_closing
		end
	MISC
	
create
	make_and_run, make
	
feature {NONE} make_and_run is
		local
			cube_model: CUBE_MODEL
			spectator: SPECTATOR
			s: CUSTOM_SETTINGS
        do
			create s
			create spectator.make(create {ANGLE3D}.make(create {ANGLE}.make(45), create {ANGLE}.make(30)), 8)
			create cube_model.make(spectator,  create {CUBE}.make(1.1), s.shuffle_count)
			make_form(cube_model, s.window_width, s.window_height, s.is_fullscreen, s.is_software_rendering, s.is_black_background)
			cube_model.run
			feature {WINFORMS_APPLICATION}.run_form(Current)
		end
	
feature {NONE} make(new_model: like model; new_width, new_height: INTEGER) is	
		require
			new_model /= Void
		do
			make_form(new_model, new_width, new_height, False, False, False)
		end
	
feature {NONE} make_form(new_model: like model; new_width, new_height: INTEGER 
						 fullscreen, software_rendering, black_background: BOOLEAN) is
		require
			new_model /= Void
		do
			model := new_model
			make_base_form
			create view.make(model, handle, Current, fullscreen, software_rendering, black_background,
							 create {DRAWING_SIZE}.make(new_width, new_height))
			model.set_observer(view)
			model.set_error_reporter(create {FULLSCREEN_ERROR_REPORTER}.make(view))
			model.set_file_select(create {FULLSCREEN_FILE_SELECT_DIALOG}.make(view))
			initialize_form
			show
			view.update
		end
	
feature {NONE} handler_on_resize(sender: SYSTEM_OBJECT args: EVENT_ARGS) is
		do
			view.update
		end
	
feature {NONE} handler_on_key_down(sender: SYSTEM_OBJECT args: WINFORMS_KEY_EVENT_ARGS) is
		local  
			key_down: WINFORMS_KEYS
			about: ABOUT_DIALOG
		do
			key_down := args.key_code()
			if key_down = feature {WINFORMS_KEYS}.escape then
				close
			elseif key_down = feature {WINFORMS_KEYS}.w then
				view.toggle_wireframe_mode
			elseif key_down = feature {WINFORMS_KEYS}.F5 then
				view.toggle_fullscreen_mode
			elseif key_down = feature {WINFORMS_KEYS}.F1 then
				view.set_window_mode
				create about.make(Current)
			elseif key_down = feature {WINFORMS_KEYS}.s then
				model.stop
			elseif model.valid_key(key_down) then
				model.process_key(key_down)      
			end
		end
	
feature {NONE} initialize_form is
		do
			set_text("Rubik's Cube")
			add_resize(create {EVENT_HANDLER}.make(Current, $handler_on_resize))
			add_key_down(create {WINFORMS_KEY_EVENT_HANDLER}.make(Current, $handler_on_key_down))
			set_icon(create {DRAWING_ICON}.make(load_resource_as_stream("cube.ico", "cube resources")))
		end
	
feature {NONE} on_paint(e: WINFORMS_PAINT_EVENT_ARGS) is
		do
			view.update
		end
	
feature {NONE} on_closing(e: SYSTEM_DLL_CANCEL_EVENT_ARGS) is
		do
			model.stop
			Precursor(e)
		end
	
feature {NONE}
	view: VIEW
	model: MODEL
	
invariant
	model /= Void
	view /= Void
	
end
