
class
	MATH_MISC
	
inherit
	MATH_CONST
	
feature deg_to_rad(angle: ANGLE): DOUBLE is
		require
			angle /= Void
		do
			Result := angle.value / 180.0 * Pi
		ensure
			Result >= 0 and Result < 2 * Pi	
		end
	
feature random_int(max_value: INTEGER random: RANDOM): INTEGER is
		require
			max_value >= 1
			random /= Void
		do
			Result := (random.real_item * max_value).ceiling - 1
			if Result < 0 then
				Result := 0
			end
		ensure
			Result >= 0 and Result < max_value
		end
	
feature double_remainder(value, divisor: DOUBLE): DOUBLE is
		require
			value >= 0
			divisor > 0
		local
			quotient: DOUBLE
		do
			quotient := value / divisor
			Result := (quotient - quotient.truncated_to_integer) * divisor
		ensure
			Result >= 0 and Result < divisor
		end			
	
feature integer_cos(half_pi_count: INTEGER): INTEGER is
		require
			half_pi_count = 1 or half_pi_count = 2 or half_pi_count = -1
		do
			inspect 
				half_pi_count
			when 1 then
				Result := 0
			when 2 then
				Result := -1
			when -1 then		
				Result := 0
			end
		ensure
			Result = -1 or Result = 0 or Result = 1 	
		end
	
feature integer_sin(half_pi_count: INTEGER): INTEGER is
		require
			half_pi_count = 1 or half_pi_count = 2 or half_pi_count = -1
		do
			inspect 
				half_pi_count
			when 1 then
				Result := 1
			when 2 then
				Result := 0
			when -1 then		
				Result := -1
			end
		ensure
			Result = -1 or Result = 0 or Result = 1 	
		end
	
end 
