
deferred class
	MODEL
	
inherit
	KEY_MANAGER 
		rename 
			make as make_key_manager
		end
	
feature set_observer(new_observer: like observer) is
		do
			observer := new_observer
		end
	
feature set_error_reporter(new_reporter: like error_reporter) is
		do
			error_reporter := new_reporter
		end	
	
feature set_file_select(new_file_select: like file_select) is
		do
			file_select := new_file_select
		end	
	
feature	run is
		deferred
		end
	
feature	stop is
		deferred
		end
	
feature	{NONE} make(new_spectator: like spectator; new_target: like target) is
		require
			new_spectator /= Void
			new_target /= Void
		do
			spectator := new_spectator
			target := new_target
			create spectator_mutex.make
			make_key_manager
		end
	
feature {NONE} set_spectator(new_spectator: like spectator) is -- Thread safe
		require
			new_spectator /= Void
		do
			dummy := spectator_mutex.wait_one
			spectator := new_spectator
			spectator_mutex.release_mutex
			notify_observer
		ensure
			-- observer notified	
		end	
	
feature {OBSERVER} get_spectator: like spectator is -- Thread safe
		do
			dummy := spectator_mutex.wait_one
			Result := spectator
			spectator_mutex.release_mutex
		end
	
feature {NONE} notify_observer is
		do
			if observer /= Void then
				observer.update
			end
		end
	
feature {NONE} 
	observer: OBSERVER
	error_reporter: ERROR_REPORTER	
	file_select: FILE_SELECT
	spectator: SPECTATOR	
	spectator_mutex: SYSTEM_MUTEX
	dummy: BOOLEAN
	
feature {OBSERVER} 
	target: VECTOR_3
	scene: RENDERABLE
	
invariant
	spectator /= Void
	target /= Void
	spectator_mutex /= Void
	
end 
