indexing
	notes: "Immutable"
	
class
	ROTATE_COUNT
	
inherit
	ANY
		redefine
			is_equal, copy
		end	
	
create 
	make
	
feature	count: INTEGER
	
feature {ROTATE_COUNT} make(new_count: like count) is
		require
			valid_count(new_count)
		do
			count := new_count
		end
	
feature	valid_count(data: like count): BOOLEAN is
		do
			Result := data = 1 or data = 2 or data = -1
		end
	
feature infix "+" (other: like Current): like Current is
		require
			other /= Void
			not_empty_new_move: (count + other.count \\ 4) /= 0
		local 
			new_count: INTEGER	
		do
			new_count := count + other.count
			if new_count > 2 then
				new_count := new_count - 4
			elseif new_count < -1 then
				new_count := new_count + 4
			end	
			create Result.make(new_count)
		end
	
feature is_equal(other: like Current): BOOLEAN is
		do
			Result := count = other.count
		end	
	
feature copy(other: like Current) is
		do
			count := other.count
		end
	
invariant
	valid_count(count)
	
end 
