indexing
	notes: "Based on Charles Petzold code"
	
class
    SCREEN_CAPTURE
	
inherit    
	EXCEPTIONS
	
feature pixel(window: POINTER x, y: INTEGER): DRAWING_COLOR is
		local
			graphics_screen, graphics_bitmap: DRAWING_GRAPHICS
			bitmap: DRAWING_BITMAP
			hdc_screen, hdc_bitmap: POINTER
			status: INTEGER
		do
			graphics_screen := feature {DRAWING_GRAPHICS}.from_hwnd(window)
			create bitmap.make(graphics_screen.visible_clip_bounds.width.truncated_to_integer, 
							   graphics_screen.visible_clip_bounds.height.truncated_to_integer, 
							   graphics_screen)
			graphics_bitmap := feature {DRAWING_GRAPHICS}.from_image(bitmap)
			hdc_screen := graphics_screen.get_hdc
			hdc_bitmap := graphics_bitmap.get_hdc
			status := bit_blt_win32_api(hdc_bitmap, 0, 0, bitmap.width, bitmap.height, hdc_screen, 0, 0, 0x00CC0020)
			if status = 0 then
				raise("BitBlt failed")
			end
			graphics_bitmap.release_hdc(hdc_bitmap)
			graphics_screen.release_hdc(hdc_screen)
			Result := bitmap.get_pixel(x, y)
		end
	
	bit_blt_win32_api(dest: POINTER x_dest, y_dest, width, height: INTEGER src: POINTER x_src, y_src, rop: INTEGER): INTEGER is
        external
			"C [macro <Windows.h>] (HDC, int, int, int, int, HDC, int, int, DWORD): EIF_BOOLEAN"
        alias
			"BitBlt"
        end
	
end 
