
class
	SIDE_COLORS
	
create 
	make
	
feature make(front_color, back_color, left_color, right_color, top_color, bottom_color: INTEGER) is
		do
			create directions.make(6)
			create colors.make(6)
			
			directions.extend(Direction.Front)
			colors.extend(front_color)
			
			directions.extend(Direction.Back)
			colors.extend(back_color)
			
			directions.extend(Direction.Left)
			colors.extend(left_color)
			
			directions.extend(Direction.Right)
			colors.extend(right_color)
			
			directions.extend(Direction.Top)
			colors.extend(top_color)
			
			directions.extend(Direction.Bottom)
			colors.extend(bottom_color)
		end
	
feature select_color(at_direction: DIRECTION): INTEGER is
		require
			at_direction /= Void
		local 
			i: INTEGER	
		do
			from i := 1 until i > Colors_count or Result /= 0 loop
				if directions.i_th(i).is_equal(at_direction) then
					Result := colors.i_th(i)
				end
				i := i + 1
			end
		ensure
			Result > 0
		end
	
feature rotate(orientation: INTEGER rotate_count: ROTATE_COUNT) is 
		require
			rotate_count /= Void
		do
			from directions.start until directions.off loop
				directions.put(directions.item.rotate(orientation, rotate_count))
				directions.forth
			end
		end
	
feature	{NONE} Direction: DIRECTION is
		once
			create Result
		end           
	
feature {NONE} 
	directions: ARRAYED_LIST[DIRECTION]
	colors: ARRAYED_LIST[INTEGER]
	Colors_count: INTEGER is 6
	
invariant
	directions /= Void 
	directions.count = Colors_count 
	not directions.has(Void)
	colors /= Void and then	colors.count = Colors_count
	
end 
