indexing
	description: "Bounded buffer for non negative integers."
	
class 
	STATISTIC_BOUNDED_BUFFER
	
create 
	make
	
	
feature {NONE} make(maximal_items_count: INTEGER) is
		require
			maximal_items_count >= 1
		do
			create buffer.make(maximal_items_count)
			update_data	
		end
	
feature min, max, avg: INTEGER
	
feature extend(new_element: INTEGER) is
		require
			new_element >= 0 
		do
			if buffer.full then
				buffer.remove
			end	
			buffer.extend(new_element)
			update_data
		end
	
feature {NONE} update_data is
		local 
			sum: DOUBLE
		do
			if buffer.is_empty then
				min := 0
				max := 0
				avg := 0
			else	
				buffer.start
				max := buffer.item_for_iteration
				min := buffer.item_for_iteration
				sum := buffer.item_for_iteration
				buffer.forth
				from until buffer.off loop
					if buffer.item_for_iteration > max then
						max := buffer.item_for_iteration
					end
					if buffer.item_for_iteration < min then
						min := buffer.item_for_iteration
					end
					sum := sum + buffer.item_for_iteration
					buffer.forth
				end
				avg := (sum / buffer.count).ceiling
			end
		end
	
feature {NONE} buffer: BOUNDED_QUEUE[INTEGER]
	
invariant
	min <= avg and avg <= max	
	not buffer.is_empty implies buffer.has(min) and	not buffer.has(min - 1)
	not buffer.is_empty implies buffer.has(max) and	not buffer.has(max + 1)
	buffer.is_empty implies min = 0 and max = 0 and avg = 0
	
end 
