indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_ANGLE3D
	
inherit 
	TEST_ROOT
	MATH_MISC
	
feature	test_to_point is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle: ANGLE3D
			expected_point: VECTOR_3
		do
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(45))
			expected_point.make(1, 1, Sqrt2)
			assert_are_equal_vector_vector(expected_point, angle.to_point(2.0), 1.0e-10)
			
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(0))
			expected_point.make(Sqrt2, Sqrt2, 0)
			assert_are_equal_vector_vector(expected_point, angle.to_point(2.0), 1.0e-10)
			
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(135))
			expected_point.make(-1, -1, Sqrt2)
			assert_are_equal_vector_vector(expected_point, angle.to_point(2.0), 1.0e-10)
		end
	
feature test_infix_add_angle is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle, add_angle, result_angle: ANGLE3D
		do
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(45))
			create add_angle.make(create {ANGLE}.make(5), create {ANGLE}.make(10))
			result_angle := angle + add_angle
			feature {ASSERT}.are_equal(50.0, result_angle.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(55.0, result_angle.vert_angle.value, 1.0e-10)
		end
	
feature test_infix_sub_angle is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle, sub_angle, result_angle: ANGLE3D
		do
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(45))
			create sub_angle.make(create {ANGLE}.make(5), create {ANGLE}.make(10))
			result_angle := angle - sub_angle
			feature {ASSERT}.are_equal(40.0, result_angle.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(35.0, result_angle.vert_angle.value, 1.0e-10)
		end
	
feature test_add_angle is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle, add_angle, result_angle: ANGLE3D
		do
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(45))
			create add_angle.make(create {ANGLE}.make(5), create {ANGLE}.make(10))
			angle.add(add_angle)
			feature {ASSERT}.are_equal(50.0, angle.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(55.0, angle.vert_angle.value, 1.0e-10)
		end
	
feature test_sub_angle is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle, sub_angle, result_angle: ANGLE3D
		do
			create angle.make(create {ANGLE}.make(45), create {ANGLE}.make(45))
			create sub_angle.make(create {ANGLE}.make(5), create {ANGLE}.make(10))
			angle.sub(sub_angle)
			feature {ASSERT}.are_equal(40.0, angle.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(35.0, angle.vert_angle.value, 1.0e-10)
		end
	
feature test_no_aliasing_in_sub is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			angle: ANGLE3D
			hor_angle, vert_angle: ANGLE
		do
			create hor_angle.make(10)
			create vert_angle.make(20)
			create angle.make(hor_angle, vert_angle)
			angle.sub(create {ANGLE3D}.make(create {ANGLE}.make(5), create {ANGLE}.make(5)))
			feature {ASSERT}.are_equal(10.0, hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(20.0, vert_angle.value, 1.0e-10)
		end
	
feature test_no_aliasing_in_infix_sub is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			original_angle, dummy: ANGLE3D
		do
			create original_angle.make(create {ANGLE}.make(10), create {ANGLE}.make(20))
			dummy := original_angle - create {ANGLE3D}.make(create {ANGLE}.make(5), create {ANGLE}.make(5))
			feature {ASSERT}.are_equal(10.0, original_angle.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(20.0, original_angle.vert_angle.value, 1.0e-10)
		end
	
end
