indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_CUBE_MODEL
	
inherit
	TEST_ROOT
	
feature	test_move_spectator_left is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10)
			model.move_spectator_left
			feature {ASSERT}.are_equal(10.0, model.get_spectator.angle.hor_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_right is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10)
			model.move_spectator_right
			feature {ASSERT}.are_equal(0.0, model.get_spectator.angle.hor_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_up is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10)
			model.move_spectator_up
			feature {ASSERT}.are_equal(10.0, model.get_spectator.angle.vert_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_down is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10)
			model.move_spectator_down
			feature {ASSERT}.are_equal(0.0, model.get_spectator.angle.vert_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_down_limited is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 300, 10)
			model.move_spectator_down
			feature {ASSERT}.are_equal(300.0, model.get_spectator.angle.vert_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_up_limited is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 60, 10)
			model.move_spectator_up
			feature {ASSERT}.are_equal(60.0, model.get_spectator.angle.vert_angle.value, 1.0e-10)
		end
	
feature	test_move_spectator_farther is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10)
			model.move_spectator_farther
			feature {ASSERT}.are_equal(10.5, model.get_spectator.distance, 1.0e-10)
		end
	
feature	test_move_spectator_closer is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			model: CUBE_MODEL
		do
			model := create_model(5, 5, 10.5)
			model.move_spectator_closer
			feature {ASSERT}.are_equal(10.0, model.get_spectator.distance, 1.0e-10)
		end
	
	
feature	test_cube_render_speed is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			form: MAIN_FORM	
			get_spectator: SPECTATOR
			i, times, start, frame_time, reserve_time: INTEGER
			model: CUBE_MODEL
			skip: BOOLEAN
		do
			if release_build then
				create get_spectator.make(create {ANGLE3D}.make(create {ANGLE}.make(45), create {ANGLE}.make(45)), 9)
				create model.make(get_spectator, create {CUBE}.make(1.1), 0)	
				create form.make(model, 200, 200) 
				
				start := feature {ENVIRONMENT}.tick_count
				times := 100
				frame_time := 10
				reserve_time := 100
				from i := 1 until i > times loop
					model.process_key(feature {WINFORMS_KEYS}.right)	
					i := i + 1
				end	
				assert_less(times * frame_time + reserve_time, feature {ENVIRONMENT}.tick_count - start)
				form.close
			end
		end
	
feature {NONE} create_model(angle1, angle2, distance: REAL):  CUBE_MODEL is
		local
			s: SPECTATOR
		do
			create s.make(create {ANGLE3D}.make(create {ANGLE}.make(angle1), create {ANGLE}.make(angle2)), distance)
			create Result.make(s, create {CUBE}.make(1), 0)
		end
	
end 
