indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_CUBE_PLANE_PARAMETERS
	
inherit
	TEST_ROOT
	
feature test_create_and_data is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane: CUBE_PLANE_PARAMETERS
		do
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			feature {ASSERT}.are_equal(1, plane.index.value)
			feature {ASSERT}.are_equal(feature {ORIENTATION}.Horizontal, plane.orientation)
		end
	
feature test_has_brick is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane: CUBE_PLANE_PARAMETERS
			brick1, brick2: IDEAL_BRICK
			sc: SIDE_COLORS
			p: IDEAL_BRICK_POSITION
		do
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			
			create p.make(create {IDEAL_CUBE_INDEX}.make(-1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			create brick1.make(sc, p) 
			feature {ASSERT}.is_true(plane.has(brick1))
			
			create p.make(create {IDEAL_CUBE_INDEX}.make(-1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1))
			create brick2.make(sc, p) 
			feature {ASSERT}.is_false(plane.has(brick2))
		end
	
end	
