indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_DIRECT3D_BRICK_DRAW
	
inherit
	TEST_ROOT 
	
	
feature test_no_bricks is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			form: MAIN_FORM
			model: BRICKS_MODEL
		do
			create model.make(create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(45), create {ANGLE}.make(45)), 5),		
							  create {VECTOR_3}.make(0, 0, 0),
							  create {BRICKS}.make)
			create form.make(model, 200, 200) 
			check_center_pixel(feature {DRAWING_COLOR}.dark_gray, form)			
			form.close
		end
	
feature test_draw_one_brick is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS	
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.from_argb(60, 60, 60), 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(45), create {ANGLE}.make(0)), 5),
							   create {VECTOR_3}.make(0, 0, 0), No_rotation)
		end
	
feature test_draw_front_side_black is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS	
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.White, feature {COLOR}.White, 
						   feature {COLOR}.White, feature {COLOR}.White, feature {COLOR}.White)
			check_single_brick(sc, feature {DRAWING_COLOR}.black, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(0)), 5),
							   create {VECTOR_3}.make(0, 0, 0), No_rotation)
		end
	
feature test_draw_front_side_along_x_white is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS	
		do
			create sc.make(feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.white, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(0)), 10),
							   create {VECTOR_3}.make(5, 0, 0), No_rotation)
		end
	
feature test_draw_left_side_along_y_blue is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Blue, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.blue, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(90), create {ANGLE}.make(0)), 10),
							   create {VECTOR_3}.make(0, 5, 0), No_rotation)
		end
	
feature test_draw_right_side_negative_y_red is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Red, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.red, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(270), create {ANGLE}.make(0)), 10),
							   create {VECTOR_3}.make(0, -5, 0), No_rotation)
		end
	
feature test_draw_back_side_pink is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Pink, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.pink, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(180), create {ANGLE}.make(0)), 5),
							   create {VECTOR_3}.make, No_rotation)
		end
	
feature test_draw_top_side_yellow is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Yellow, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.yellow, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(90)), 5),
							   create {VECTOR_3}.make(0, 0, 0), No_rotation)
		end
	
feature test_draw_bottom_side_white is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.White)
			check_single_brick(sc, feature {DRAWING_COLOR}.white, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(270)), 5),
							   create {VECTOR_3}.make(0, 0, 0), No_rotation)
		end
	
feature test_draw_two_bricks_and_z_buffer is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			form: MAIN_FORM
			bricks: BRICKS
			model: BRICKS_MODEL
			sc: SIDE_COLORS
		do
			create bricks.make
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Green, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			bricks.extend(create {BRICK}.make(sc, create {VECTOR_3}.make(0, 1, 0), No_rotation))
			
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black)
			bricks.extend(create {BRICK}.make(sc, create {VECTOR_3}.make(0, -1, 0), No_rotation))
			
			create model.make(create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(90), create {ANGLE}.make(0)), 5),
							  create {VECTOR_3}.make(0, 0, 0),  bricks)
			
			create form.make(model, 200, 200) 
			check_center_pixel(feature {DRAWING_COLOR}.green, form)			
			
			model.set_spectator(create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(270), create {ANGLE}.make(0)), 5))
			check_center_pixel(feature {DRAWING_COLOR}.white, form)			
			form.close
		end
	
	
feature test_rotate_around_y is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.White, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.white, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(45)), 20),
							   create {VECTOR_3}.make(0, 0, 0), 
							   create {ROTATION_ANGLE}.make(create {ANGLE}.make(0), create {ANGLE}.make(45), create {ANGLE}.make(0)))
		end
	
feature test_rotate_around_x is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.White)
			check_single_brick(sc, feature {DRAWING_COLOR}.white, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(90), create {ANGLE}.make(0)), 20),
							   create {VECTOR_3}.make(0, 0, 0), 
							   create {ROTATION_ANGLE}.make(create {ANGLE}.make(90), create {ANGLE}.make(0), create {ANGLE}.make(0)))
		end
	
feature test_rotate_around_z is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			sc: SIDE_COLORS
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black)
			check_single_brick(sc, feature {DRAWING_COLOR}.white, 
							   create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(0)), 20),
							   create {VECTOR_3}.make(0, 0, 0), 
							   create {ROTATION_ANGLE}.make(create {ANGLE}.make(0), create {ANGLE}.make(0), create {ANGLE}.make(90)))
		end
	
feature test_complex_rotate is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			form: MAIN_FORM
			bricks: BRICKS
			brick: BRICK
			sc: SIDE_COLORS
			model: BRICKS_MODEL
		do
			create sc.make(feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			create brick.make(sc, create {VECTOR_3}.make(1, 1, -1),
							  create {ROTATION_ANGLE}.make(create {ANGLE}.make(180), create {ANGLE}.make(270), create {ANGLE}.make(90)))
			create bricks.make
			bricks.extend(brick)
			
			create model.make(create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(90)), 10),
							  create {VECTOR_3}.make(1, -1, 1),  bricks)
			create form.make(model, 200, 200) 
			check_center_pixel(feature {DRAWING_COLOR}.white, form)			
			form.close
		end
	
	
feature test_view_target is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			form: MAIN_FORM
			bricks: BRICKS
			brick: BRICK
			sc: SIDE_COLORS
			model: BRICKS_MODEL
		do
			create sc.make(feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			create brick.make(sc, create {VECTOR_3}.make(0, 10, 0), No_rotation)
			create bricks.make
			bricks.extend(brick)
			
			create model.make(create {SPECTATOR}.make(create {ANGLE3D}.make(create {ANGLE}.make(0), create {ANGLE}.make(0)), 40),
							  create {VECTOR_3}.make(0, 10, 0),  bricks)
			create form.make(model, 200, 200) 
			check_center_pixel(feature {DRAWING_COLOR}.white, form)			
			form.close
		end
	
	
feature {NONE} check_center_pixel(expected: DRAWING_COLOR form: MAIN_FORM) is
		require
			form /= Void
		local 
			actual: DRAWING_COLOR
			capture: SCREEN_CAPTURE
		do		
			create capture
			actual := capture.pixel(form.handle, 
									form.client_rectangle.width // 2, 
									form.client_rectangle.height // 2)
			feature {ASSERT}.are_equal(expected.to_argb, actual.to_argb)
		end		
	
feature {NONE} check_single_brick(sc: SIDE_COLORS expected: DRAWING_COLOR spectator: SPECTATOR p: VECTOR_3 angle: ROTATION_ANGLE) is
		require
			sc /= Void
			spectator /= Void
			angle /= Void
		local 
			form: MAIN_FORM
			bricks: BRICKS
			model: BRICKS_MODEL
		do
			create bricks.make
			bricks.extend(create {BRICK}.make(sc, p, angle))
			create model.make(spectator, create {VECTOR_3}.make(0, 0, 0), bricks)
			create form.make(model, 200, 200) 
			check_center_pixel(expected, form)			
			form.close
		end
	
feature {NONE} No_rotation: ROTATION_ANGLE	is
		once
			create Result.make(create {ANGLE}.make(0), create {ANGLE}.make(0), create {ANGLE}.make(0))
		end
	
end 
