indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_FLYBY
	
inherit
	TEST_ROOT	
	
feature	test_creation_and_final is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, final: ANGLE3D
		do
			create original.make(create {ANGLE}.make(1.1), create {ANGLE}.make(2.2))
			create f.make(original, 10, 2, 1)
			final := f.final
			feature {ASSERT}.are_equal(1.1, final.hor_angle.value, 1.0e-10)
			feature {ASSERT}.are_equal(2.2, final.vert_angle.value, 1.0e-10)
		end
	
feature	test_horizontal_angle_small_start_value is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(10), create {ANGLE}.make(0))
			create f.make(original, 10, 1, 1)
			now := f.now(0)
			feature {ASSERT}.are_equal(10.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(5)
			feature {ASSERT}.are_equal(190.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(10)
			feature {ASSERT}.are_equal(10.0, now.hor_angle.value, 1.0e-10)
		end
	
feature	test_horizontal_angle_big_start_value is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(270), create {ANGLE}.make(0))
			create f.make(original, 36, 1, 1)
			now := f.now(0)
			feature {ASSERT}.are_equal(270.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(9)
			feature {ASSERT}.are_equal(0.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(18)
			feature {ASSERT}.are_equal(90.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(36)
			feature {ASSERT}.are_equal(270.0, now.hor_angle.value, 1.0e-10)
		end
	
feature	test_horizontal_angle_rotate_count_two is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(0), create {ANGLE}.make(0))
			create f.make(original, 8, 2, 1)
			now := f.now(0)
			feature {ASSERT}.are_equal(0.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(2)
			feature {ASSERT}.are_equal(180.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(7)
			feature {ASSERT}.are_equal(270.0, now.hor_angle.value, 1.0e-10)
			
			now := f.now(8)
			feature {ASSERT}.are_equal(0.0, now.hor_angle.value, 1.0e-10)
		end
	
feature	test_vertical_angle_original_up is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(0), create {ANGLE}.make(8))
			create f.make(original, 8, 1, 1)
			
			now := f.now(0)
			feature {ASSERT}.are_equal(8.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(1)
			feature {ASSERT}.are_equal(4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(2)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(3)
			feature {ASSERT}.are_equal(360.0 - 4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(4)
			feature {ASSERT}.are_equal(360.0 - 8.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(5)
			feature {ASSERT}.are_equal(360.0 - 4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(6)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(7)
			feature {ASSERT}.are_equal(4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(8)
			feature {ASSERT}.are_equal(8.0, now.vert_angle.value, 1.0e-10)
		end
	
feature	test_vertical_angle_original_down is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(0), create {ANGLE}.make(360 - 8))
			create f.make(original, 8, 1, 1)
			
			now := f.now(0)
			feature {ASSERT}.are_equal(360.0 - 8.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(1)
			feature {ASSERT}.are_equal(360.0 - 4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(2)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(3)
			feature {ASSERT}.are_equal(4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(4)
			feature {ASSERT}.are_equal(8.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(5)
			feature {ASSERT}.are_equal(4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(6)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(7)
			feature {ASSERT}.are_equal(360.0 - 4.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(8)
			feature {ASSERT}.are_equal(360.0 - 8.0, now.vert_angle.value, 1.0e-10)
		end
	
feature	test_vertical_angle_oscillation_count_two is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			f: FLYBY
			original, now: ANGLE3D
		do
			create original.make(create {ANGLE}.make(0), create {ANGLE}.make(16))
			create f.make(original, 32, 1, 2)
			
			now := f.now(4)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(16 + 8)
			feature {ASSERT}.are_equal(360.0 - 16.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(16 + 12)
			feature {ASSERT}.are_equal(0.0, now.vert_angle.value, 1.0e-10)
			
			now := f.now(16 + 14)
			feature {ASSERT}.are_equal(8.0, now.vert_angle.value, 1.0e-10)
		end
	
end 
