indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_IDEAL_BRICK
	
inherit
	TEST_ROOT
	
feature test_make_and_data is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			brick: IDEAL_BRICK
			sc: SIDE_COLORS
			p: IDEAL_BRICK_POSITION
		do
			create sc.make(feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			create p.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1))
			create brick.make(sc, p) 
			feature {ASSERT}.are_equal(feature {COLOR}.Black, brick.colors.select_color(Direction.Front))
			feature {ASSERT}.are_equal(1, brick.position.x.value)
		end
	
feature test_rotate is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			brick: IDEAL_BRICK
			expected: IDEAL_BRICK_POSITION
			sc: SIDE_COLORS
			p: IDEAL_BRICK_POSITION
		do
			create sc.make(feature {COLOR}.White, feature {COLOR}.Black, feature {COLOR}.Black, 
						   feature {COLOR}.Black, feature {COLOR}.Black, feature {COLOR}.Black)
			create p.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))			   
			create brick.make(sc, p)
			brick.rotate(feature {ORIENTATION}.Vertical_perpendicular_to_y, create {ROTATE_COUNT}.make(-1))	
			
			feature {ASSERT}.are_equal(feature {COLOR}.White, brick.colors.select_color(Direction.Top))
			create expected.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			assert_are_equal_position_position(expected, brick.position)
		end
	
feature	{NONE} Direction: DIRECTION is
		once
			create Result
		end           
	
end
