indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_IDEAL_BRICK_POSITION
inherit
	TEST_ROOT
	
feature test_equal is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			p1, p2: IDEAL_BRICK_POSITION
		do
			create p1.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			create p2.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			feature {ASSERT}.is_true(p1.is_equal(p2))
		end
	
feature test_not_equal is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			p1, p2: IDEAL_BRICK_POSITION
		do
			create p1.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			create p2.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(1))
			feature {ASSERT}.is_false(p1.is_equal(p2))
		end
	
feature test_rotate_around_z is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			p, expected, actual: IDEAL_BRICK_POSITION
		do
			create p.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))
			create expected.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0))
			actual := p.rotate(feature {ORIENTATION}.Horizontal, create {ROTATE_COUNT}.make(1))
			assert_are_equal_position_position(expected, actual)
		end
	
feature test_rotate_around_x is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			p, expected, actual: IDEAL_BRICK_POSITION
		do
			create p.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			create expected.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1), create {IDEAL_CUBE_INDEX}.make(0))
			actual := p.rotate(feature {ORIENTATION}.Vertical_perpendicular_to_x, create {ROTATE_COUNT}.make(1))
			assert_are_equal_position_position(expected, actual)
		end
	
feature test_rotate_around_y is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			p, expected, actual: IDEAL_BRICK_POSITION
		do
			create p.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			create expected.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0))
			actual := p.rotate(feature {ORIENTATION}.Vertical_perpendicular_to_y, create {ROTATE_COUNT}.make(1))
			assert_are_equal_position_position(expected, actual)
		end
	
feature test_immutable_on_rotate is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			original, object_under_test, dummy: IDEAL_BRICK_POSITION
		do
			create original.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(-1))
			object_under_test := deep_clone(original)
			dummy := object_under_test.rotate(feature {ORIENTATION}.Horizontal, create {ROTATE_COUNT}.make(1))
			assert_are_equal_position_position(original, object_under_test)
		end
	
end	
