indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_IDEAL_CUBE
	
inherit
	TEST_ROOT
	
	
feature test_call_create is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			cube: IDEAL_CUBE
		do
			create cube
		end
	
feature test_call_play_move is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			cube: IDEAL_CUBE
			move: PLAYER_MOVE
		do
			create cube
			create move.make(create {CUBE_PLANE_PARAMETERS}.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(0)), 
							 create {ROTATE_COUNT}.make(1))
			cube.play_move(move)
		end
	
feature test_select_plane is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			cube: IDEAL_CUBE
			actual: ARRAYED_LIST[IDEAL_BRICK]	  
			plane: CUBE_PLANE_PARAMETERS
		do
			create cube
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(0))
			actual := cube.select_plane(plane)
			feature {ASSERT}.are_equal(9, actual.count)
			feature {ASSERT}.is_true(0 = actual.i_th(1).position.z.value)
		end
	
feature test_select_all_except_plane is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			cube: IDEAL_CUBE
			actual: ARRAYED_LIST[IDEAL_BRICK]	 
			plane: CUBE_PLANE_PARAMETERS 
		do
			create cube
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(0))
			actual := cube.select_all_except_plane(plane)
			feature {ASSERT}.are_equal_integer_integer(18, actual.count)
			feature {ASSERT}.is_false(0 = actual.i_th(1).position.z.value)
		end
	
feature test_is_solved is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			cube: IDEAL_CUBE
		do
			create cube
			feature {ASSERT}.is_true(cube.is_solved)
		end
	
feature test_is_not_solved is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			cube: IDEAL_CUBE
			plane: CUBE_PLANE_PARAMETERS 
		do
			create cube
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(0))
			cube.play_move(create {PLAYER_MOVE}.make(plane, create {ROTATE_COUNT}.make(1)))
			feature {ASSERT}.is_false(cube.is_solved)
		end
	
feature test_select_brick is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			cube: IDEAL_CUBE
			p: IDEAL_BRICK_POSITION
			actual: IDEAL_BRICK
		do
			create cube
			create p.make(create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(1))
			actual := cube.select_brick(p)
			feature {ASSERT}.are_equal(feature {COLOR}.Yellow, actual.colors.select_color(Direction.Top))
		end
	
feature	{NONE} Direction: DIRECTION is
		once
			create Result
		end           
	
end
