indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_MATH_MISC
	
inherit
	MATH_MISC	
	TEST_ROOT
	
feature test_deg_to_rad is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		do
			feature {ASSERT}.are_equal(Pi, deg_to_rad(create {ANGLE}.make(180)), 1.0e-10)
		end
	
feature test_random_int is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			i, rnd, rnd0, rnd1, rnd2: INTEGER
			random: RANDOM
			variation, test_count: INTEGER
		do
			create random.set_seed(5)
			test_count := 1000
			variation := test_count * 5 // 100  -- 5%
			from i := 1 until i > test_count * 3 loop
				rnd := random_int(3, random); random.forth
				inspect 
					rnd
				when 0 then
					rnd0 := rnd0 + 1
				when 1 then
					rnd1 := rnd1 + 1 
				when 2 then				
					rnd2 := rnd2 + 1
				end				
				i := i + 1
			end
			assert_less(variation, (rnd0 - test_count).abs)
			assert_less(variation, (rnd1 - test_count).abs)
			assert_less(variation, (rnd2 - test_count).abs)
		end
	
feature test_remainder is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		do
			feature {ASSERT}.are_equal(1.0, double_remainder(1, 8), 1.0e-10)		
			feature {ASSERT}.are_equal(1.1, double_remainder(9.1, 8.0), 1.0e-10)		
		end	
	
feature test_integer_cos is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		do
			feature {ASSERT}.are_equal(0, integer_cos(1))
		end
	
feature test_integer_sin is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		do
			feature {ASSERT}.are_equal(1, integer_sin(1))
		end
	
end 
