indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_MISC
	
inherit 
	MISC	
	TEST_ROOT
	
feature test_point_to_string is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			actual: STRING
		do
			actual := point_to_string(create {VECTOR_3}.make(1.3, 2.2, 3.1))
			assert_are_equal_string_string("[x = 1.3 y = 2.2 z = 3.1]", actual)
		end
	
feature test_ideal_point_to_string is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local
			p: IDEAL_BRICK_POSITION
		do
			create p.make(create {IDEAL_CUBE_INDEX}.make(1), create {IDEAL_CUBE_INDEX}.make(0), create {IDEAL_CUBE_INDEX}.make(-1))
			assert_are_equal_string_string("[x = 1 y = 0 z = -1]", ideal_point_to_string(p))
		end
	
feature test_move_to_string is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane: CUBE_PLANE_PARAMETERS
			move: PLAYER_MOVE
		do
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			create move.make(plane, create {ROTATE_COUNT}.make(1))
			assert_are_equal_string_string("[Plane: hor 1 Rotate: 1]", move_to_string(move))
		end
	
feature test_last_exception_type is	
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			i: INTEGER
			exception_type: STRING
			exception_occured: BOOLEAN
		do
			if not exception_occured then
				i := 1 // 0
			else
				assert_are_equal_string_string("System.DivideByZeroException", exception_type)
			end
		rescue
			if not exception_occured then
				exception_occured := True
				exception_type := last_exception_type
				retry
			end		
		end
	
end 
