indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_PLAYER_MOVE
	
inherit
	TEST_ROOT
	
feature test_create_and_access is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane: CUBE_PLANE_PARAMETERS
			move: PLAYER_MOVE
		do
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			create move.make(plane, create {ROTATE_COUNT}.make(1))
			feature {ASSERT}.are_equal(1, move.rotate_count.count)
		end
	
feature test_equal is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane: CUBE_PLANE_PARAMETERS
			move1, move2: PLAYER_MOVE
		do
			create plane.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			create move1.make(plane, create {ROTATE_COUNT}.make(1))
			create move2.make(clone(plane), create {ROTATE_COUNT}.make(1))
			feature {ASSERT}.is_true(move1.is_equal(move2))
		end
	
feature test_not_equal is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			plane1, plane2, plane3, plane4: CUBE_PLANE_PARAMETERS
			move1, move2, move3, move4: PLAYER_MOVE
		do
			create plane1.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			create move1.make(plane1, create {ROTATE_COUNT}.make(1))
			
			create plane2.make(feature {ORIENTATION}.Vertical_perpendicular_to_x, create {IDEAL_CUBE_INDEX}.make(1))
			create move2.make(plane2, create {ROTATE_COUNT}.make(1))
			feature {ASSERT}.is_false(move1.is_equal(move2))
			
			create plane3.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(0))
			create move3.make(plane3, create {ROTATE_COUNT}.make(1))
			feature {ASSERT}.is_false(move1.is_equal(move3))
			
			create plane4.make(feature {ORIENTATION}.Horizontal, create {IDEAL_CUBE_INDEX}.make(1))
			create move4.make(plane4, create {ROTATE_COUNT}.make(2))
			feature {ASSERT}.is_false(move1.is_equal(move4))
		end
	
end	
