indexing
	description: "Base class for unit tests"
	
class
	TEST_ROOT
	
inherit
	MISC	
	
feature release_build: BOOLEAN is
		local
			exception_occured: BOOLEAN
		do
			if not exception_occured then
				check False end
				Result := True
			else
				Result := False
			end		
		rescue
			exception_occured := True
			retry	
		end
	
feature assert_less(bigger, smaller: DOUBLE) is
		do
			if smaller >= bigger then
				feature {ASSERT}.fail_string(smaller.out + " isn't smaller than " + bigger.out)
			end
		end
	
feature assert_are_equal_vector_vector(expected, actual: VECTOR_3 expected_delta: REAL) is 
		local 
			message: STRING
		do
			if (expected - actual).length > expected_delta then
				message := "expected: " +  point_to_string(expected) + " but was: " + point_to_string(actual)
				feature {ASSERT}.fail_string(message)
			end
		end
	
feature assert_are_equal_position_position(expected, actual: IDEAL_BRICK_POSITION) is 
		do
			assert_are_equal(expected, actual, agent ideal_point_to_string)
		end
	
feature assert_are_equal_move_move(expected, actual: PLAYER_MOVE) is 
		do
			assert_are_equal(expected, actual, agent move_to_string)
		end
	
feature assert_are_equal_string_string(expected, actual: STRING) is 
		do
			assert_are_equal(expected, actual, agent {STRING}.out)
		end
	
feature {NONE} assert_are_equal(expected, actual: ANY print_function: FUNCTION[ANY, TUPLE[ANY], STRING]) is 
		require
			expected /= Void
			actual /= Void
			print_function /= Void
		local 
			message: STRING
		do
			if not expected.is_equal(actual) then
				message := "expected: " +  print_function.item([expected]) + " but was: " + print_function.item([actual])
				feature {ASSERT}.fail_string(message) 
			end
		end
	
feature {NONE} turn_on_assertions is
		indexing
			attribute: create {TEST_FIXTURE_SET_UP_ATTRIBUTE}.make end
		do
			feature {ISE_RUNTIME}.initialize_assertions(Current.get_type.type_handle)	
			custom_fixture_setup
		end
	
	
feature {NONE} custom_fixture_setup is
		do
		end		
	
	
end 
