indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make	end
	
class
	TEST_STATISTIC_BOUNDED_BUFFER
	
inherit
	TEST_ROOT
	
	
feature	test_buffer_empty is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			buffer: STATISTIC_BOUNDED_BUFFER
		do
			create buffer.make(3)
			feature {ASSERT}.are_equal(0, buffer.min, "min")
			feature {ASSERT}.are_equal(0, buffer.max, "max")
			feature {ASSERT}.are_equal(0, buffer.avg, "avg")
		end
	
feature	test_buffer_not_full is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			buffer: STATISTIC_BOUNDED_BUFFER
		do
			create buffer.make(3)
			buffer.extend(2)
			buffer.extend(4)
			feature {ASSERT}.are_equal(2, buffer.min, "min")
			feature {ASSERT}.are_equal(4, buffer.max, "max")
			feature {ASSERT}.are_equal(3, buffer.avg, "avg")
		end
	
feature	test_buffer_full is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			buffer: STATISTIC_BOUNDED_BUFFER
		do
			create buffer.make(3)
			buffer.extend(9)		
			buffer.extend(2)
			buffer.extend(4)		
			
			feature {ASSERT}.are_equal(2, buffer.min, "min")
			feature {ASSERT}.are_equal(9, buffer.max, "max")
			feature {ASSERT}.are_equal(5, buffer.avg, "avg")
		end
	
feature	test_buffer_owerflow is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make	end
		local 
			buffer: STATISTIC_BOUNDED_BUFFER
		do
			create buffer.make(3)
			buffer.extend(9)		
			buffer.extend(2)
			buffer.extend(3)		
			buffer.extend(1)				
			
			feature {ASSERT}.are_equal(1, buffer.min, "min")
			feature {ASSERT}.are_equal(3, buffer.max, "max")
			feature {ASSERT}.are_equal(2, buffer.avg, "avg")
		end
	
feature	test_speed is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		local 
			buffer: STATISTIC_BOUNDED_BUFFER
			i, start, dummy: INTEGER
		do
			if release_build then
				create buffer.make(100)
				from i := 1 until i > 100 loop
					buffer.extend(i)
					i := i + 1			
				end
				
				start := feature {ENVIRONMENT}.tick_count
				from i := 1 until i > 1000 loop
					buffer.extend(i)
					dummy := buffer.min
					dummy := buffer.max
					dummy := buffer.avg
					i := i + 1
				end	
				assert_less(500, feature {ENVIRONMENT}.tick_count - start) -- Maximum 5% CPU usage allowed at 100 fps
			end	
		end		
	
end
