indexing
	attribute: create {TEST_FIXTURE_ATTRIBUTE}.make end
	
class
	TEST_THREAD_SYNCHRONIZATION
	
inherit
	TEST_ROOT
	
	
feature	test_mutex_synchronization is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end
		do
			create mutex.make
			run_test($process_data_synchronized, agent set_value_synchronized, First_thread_data)
		end
	
feature	test_no_synchronization is
		indexing
			attribute: create {TEST_ATTRIBUTE}.make end 
		do
			create mutex.make
			run_test($process_data_without_synchronization, agent set_value_without_synchronization, Second_thread_data)
		end
	
feature {NONE} run_test(second_thread_method: POINTER
						first_thread_method: PROCEDURE[ANY, TUPLE[INTEGER, INTEGER]]
						expected_value: INTEGER) is
		local
			second_thread: SYSTEM_THREAD
		do
			create second_thread.make(create {THREAD_START}.make(Current, second_thread_method))
			second_thread.start
			
			feature {SYSTEM_THREAD}.sleep_integer(Time_for_second_thread_to_start_ms)
			first_thread_method.call([First_thread_data, 0])
			
			second_thread.join
			feature {ASSERT}.are_equal(expected_value, shared_value)
		end	
	
feature {NONE} process_data_synchronized is
		do
			set_value_synchronized(Second_thread_data, Time_for_second_thread_to_wait_first_thread_ms)
		end	
	
feature {NONE} process_data_without_synchronization is
		do
			set_value_without_synchronization(Second_thread_data, Time_for_second_thread_to_wait_first_thread_ms)
		end	
	
	
feature {NONE} set_value_synchronized(new_value: INTEGER sleep_time: INTEGER) is
		require 
			mutex /= Void
			sleep_time >= 0
		local 
			dummy: BOOLEAN
		do
			dummy := mutex.wait_one
			feature {SYSTEM_THREAD}.sleep_integer(sleep_time)
			shared_value := new_value 
			mutex.release_mutex
		end
	
feature {NONE} set_value_without_synchronization(new_value: INTEGER sleep_time: INTEGER) is
		require
			sleep_time >= 0
		do
			feature {SYSTEM_THREAD}.sleep_integer(sleep_time)
			shared_value := new_value 
		end
	
feature {NONE}
	shared_value: INTEGER 
	mutex: SYSTEM_MUTEX
	Time_for_second_thread_to_start_ms: INTEGER is 150
	Time_for_second_thread_to_wait_first_thread_ms: INTEGER is 300
	First_thread_data, Second_thread_data: INTEGER is unique
	
end 
