
class
	THREAD_SAFE_BOOLEAN
	
inherit
	ANY 
		redefine
			default_create
		end
	
create 
	default_create, make_from_boolean
	
convert
	is_true: {BOOLEAN},
	make_from_boolean({BOOLEAN})
	
feature make_from_boolean(new_value: BOOLEAN) is
		do
			default_create
			set_value(new_value)
		end
	
feature {NONE} default_create is
		do
			create mutex.make
		end
	
feature is_true: BOOLEAN is
		do
			Result := get_value
		end
	
feature prefix "not": BOOLEAN is
		do
			Result := not is_true
		end
	
feature {NONE} set_value(new_value: BOOLEAN) is
		do
			dummy := mutex.wait_one
			bool_impl := new_value
			mutex.release_mutex
		ensure
			get_value = new_value
		end
	
feature {NONE} get_value: BOOLEAN is
		do
			dummy := mutex.wait_one
			Result := bool_impl
			mutex.release_mutex
		end
	
feature {NONE} 
	mutex: SYSTEM_MUTEX 
	bool_impl: BOOLEAN	
	dummy: BOOLEAN	
	
invariant
	mutex /= Void
	
end 
